package com.fear1ess.reyunaditool;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONObject;

import java.io.IOException;
import java.lang.ref.WeakReference;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

import static com.fear1ess.reyunaditool.DoWorkThread.getAppInfoUrlStr;
import static com.fear1ess.reyunaditool.ExecuteCmdUtils.executeCmd;

public class MainActivity extends AppCompatActivity {

   public static String m_Android_ID="";
    public static Button m_startBtn=null;
    public static Button m_stopBtn=null;
    public static String m_myPackageName="";
    public static Context m_context=null;
    //保持屏幕常量的表示
    public static boolean m_isShow=false;
    //
//    public static Handler m_handler=new MainActivityHandler();


    @RequiresApi(api = Build.VERSION_CODES.O)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        try{
            LocalService.m_comtext=getApplicationContext();
            RemoteService.m_comtext=getApplicationContext();
//            startService(new Intent(this, LocalService.class));

            AdiToolApp app = (AdiToolApp) getApplication();

            Button startBtn = findViewById(R.id.start_btn);
            m_startBtn=startBtn;
            Button stopBtn = findViewById(R.id.stop_btn);
            m_stopBtn=stopBtn;
            stopBtn.setEnabled(false);

            TextView textView=findViewById(R.id.user_ID);
            m_Android_ID= Settings.System.getString(getContentResolver(), Settings.System.ANDROID_ID);
            String user="当前APP的Android ID: "+m_Android_ID;
            textView.setText(user);
            m_myPackageName=getPackageName();
            m_context=getApplicationContext();

            requestPermissions(new String[]{"android.permission.WRITE_EXTERNAL_STORAGE",
                    "android.permission.READ_EXTERNAL_STORAGE"},100);

            startForegroundService(new Intent(MainActivity.this, DoCommandService.class));
            startBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    try{
                        startBtn.setText("Working");
                        startBtn.setEnabled(false);
                        stopBtn.setEnabled(true);
                        Context cxt = AdiToolApp.getAppContext();
                        startForegroundService(new Intent(MainActivity.this, DoCommandService.class));
                    }catch (Exception e){
                        MyLog.d("startBtn -> setOnClickListener ："+e.toString());
                    }

                }
            });

            stopBtn.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    try{
                        Context cxt = AdiToolApp.getAppContext();
                        stopService(new Intent(cxt, DoCommandService.class));
                        startBtn.setText("Start");
                        startBtn.setEnabled(true);
                        stopBtn.setEnabled(false);

                    }catch (Exception e){
                        MyLog.d("stopBtn -> setOnClickListener ："+e.toString());
                    }

                }
            });

            new Thread(){
                @Override
                public void run() {
                    try {
                        Thread.sleep(5000);

                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            startBtn.performClick();
                        }
                    });
                }
            }.start();
            m_isShow=false;
            new Thread(new Runnable() {
                @Override
                public void run() {
                    while (true){
                        try {
//                        Log.d("myTest","保持屏幕常量状态中");
                            Thread.sleep(60*1000);
                            executeCmd("ls");

                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        if(m_isShow){
                            break;
                        }
                    }
                }
            }).start();
        }catch (Exception e){
            MyLog.d("MainActivity -> onCreate "+e.toString());
        }




    }

    public void onClick2(View view) {
        new Thread(new Runnable() {
            @Override
            public void run() {
                JSONObject jsonObject=null;
                OkHttpClient client = new OkHttpClient().newBuilder()
                        .build();
                Request request = new Request.Builder()
//                        .url("http://adfly-api.adinsights-global.com/get_app_res/?count=1&ua=android")

                        .url("http://8.210.2.192/get_app_res/?count=1&ua=android")
                        .method("GET", null)
                        .build();
                try {
                    Response response = client.newCall(request).execute();
                    String result= new String(response.body().bytes());
                    jsonObject=new JSONObject(result);
                    MyLog.d(jsonObject.toString());
                } catch (Exception e) {
                    MyLog.error(""+e.toString());
                }
            }
        }).start();
    }

    public static class MainActivityHandler extends Handler{
        public static final int NETWORK_ERROR = 0;
        public static final int StartMySlef = 11;
        private WeakReference<Activity> mActivityWeakRef = null;

        public MainActivityHandler(Activity activity){
            mActivityWeakRef = new WeakReference<>(activity);
        }

//        public MainActivityHandler() {
//
//        }

        @Override
        public void handleMessage(@NonNull Message msg) {
            switch (msg.what){
                case NETWORK_ERROR:
                    CharSequence errText = msg.getData().getCharSequence("errText");
                    Toast t = Toast.makeText(mActivityWeakRef.get(),errText,Toast.LENGTH_SHORT);
                    t.show();
                    break;
                case StartMySlef:
                    startMySelf();
                    break;
                default:
                    break;
            }
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        try{
            if(m_isShow){
                startMySelf();
            }

//            Toast.makeText(MainActivity.m_context,"开始卸载APP",Toast.LENGTH_LONG).show();
        }catch (Exception e){

        }
    }
    public static void startMySelf(){
        try{
            if(MainActivity.m_context==null)return;
            int result= ExecuteCmdUtils.startApp(MainActivity.m_context, MainActivity.m_myPackageName);
           if(result ==-1){
               MyLog.error("启动Activity结果失败");
           }else {
               MyLog.error("启动Activity结果成功");
           }
        }catch (Exception e){
            MyLog.error(e.toString());
        }

    }
}