package com.fear1ess.reyunaditool;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.InputStreamReader;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;



public class Tool {
    public static void sleep(int sec){
        try {
            Thread.sleep(sec*1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public static void renameFile(String srcPath,String reNamePath){
        File fi = new File(srcPath);
        File fi2 = new File(reNamePath);
        fi.renameTo(fi2);
    }



    public static ArrayList<String> rootCommand(String command) {

        MyLog.d("执行命令：" + command);
        BufferedReader successReader = null;
        BufferedReader errorReader = null;
        StringBuilder errorMsg = null;
        ArrayList<String> results = new ArrayList<String>();
        Process process = null;
        DataOutputStream os = null;
        try {
            process = Runtime.getRuntime().exec("su");
            os = new DataOutputStream(process.getOutputStream());
            os.writeBytes(command + "\n");
            os.writeBytes("exit\n");
            os.flush();
            process.waitFor();
            //读取信息
            errorMsg = new StringBuilder();
            successReader = new BufferedReader(new InputStreamReader(
                    process.getInputStream()));
            errorReader = new BufferedReader(new InputStreamReader(
                    process.getErrorStream()));
            String lineStr;
            results.add("success");
            //获取正常输出的信息
            while ((lineStr = successReader.readLine()) != null) {
                results.add(lineStr);
            }
            //获取产生错误时的信息
            while ((lineStr = errorReader.readLine()) != null) {
                errorMsg.append(lineStr);
            }
            if (errorMsg.toString().length() > 5) {
                if (results.size()>0){
                    results.clear();
                    results.add("failure");
                }
//                MyLog.d("执行命令：" + command + " 错误 信息是：" + errorMsg.toString());
                results.add(errorMsg.toString());
            }

        } catch (Exception e) {
            return null;
        } finally {
            try {
                if (os != null) {
                    os.close();
                }
                process.destroy();
            } catch (Exception e) {

            }

        }
        return results;

    }

    public static long dateToStamp(String s)  {
        long res=0;
        //设置时间模版
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = null;
        try {
            date = simpleDateFormat.parse(s);
            if (date!=null){
                res = date.getTime();
            }

        } catch (ParseException e) {
            e.printStackTrace();
        }

        return res;
    }



}
