package com.fear1ess.reyunaditool.thread;

import android.content.Context;

import android.os.Handler;
import android.text.TextUtils;
import android.util.Log;

import com.fear1ess.reyunaditool.AppInfo;
import com.fear1ess.reyunaditool.DoCommandService;
import com.fear1ess.reyunaditool.ExecuteCmdUtils;
import com.fear1ess.reyunaditool.MyLog;
import com.fear1ess.reyunaditool.NetWorkUtils;
import com.fear1ess.reyunaditool.Tool;
import com.fear1ess.reyunaditool.state.AppState;
import com.fear1ess.reyunaditool.utils.PushMsgUtils;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;

import static com.fear1ess.reyunaditool.NetWorkUtils.getDwonURL;


public class DownloadThread extends Thread {
    private Handler mainUiHandler;
    private Context appContext;
    private DoCommandService mService;
    private volatile boolean needRunning = true;

    private int MAX_APPHANDLE_SIZE = 2;
    public LinkedBlockingQueue<AppInfo> mAppInfoQueue = new LinkedBlockingQueue<>(MAX_APPHANDLE_SIZE);

    public static String downloadDir = "/sdcard/reyundownload";

    public static String TAG = "reyunaditool_log";

   // public static String downloadAppUrlStr = "http://adfly-api.adinsights-global.com/get_app_res/?count=1&ua=and";
    public static String downloadAppUrlStr = "http://8.210.2.192/get_app_res/?count=1&ua=android";

    static{
        File fi = new File(downloadDir);
        if(!fi.exists()) fi.mkdirs();
    }

    public DownloadThread(Context cxt, Handler handler, DoCommandService doCommandService) {
        appContext = cxt;
        mainUiHandler = handler;
        mService = doCommandService;
    }

    public String downloadApp(String downloadUrl, String downloadPath) {
        Log.d(TAG, "downloadApp...");
        NetWorkUtils.Response res = NetWorkUtils.download(downloadUrl,null,null,downloadPath);
        MyLog.d("downloadApp 结果："+res);
        if(res == null) return null;
        return res.resFileName;
    }

    public void renameFile(String srcPath,String reNamePath){
        File fi = new File(srcPath);
        File fi2 = new File(reNamePath);
        fi.renameTo(fi2);
    }

    public void exit() {
        needRunning = false;
    }

    public void handleLocalApp(){
        File fi = new File(downloadDir);
        String[] fileNames = fi.list();
        if(fileNames == null) return;
        for(String fileName : fileNames){
            String packageName = fileName.replace(".apk","");
            String downloadPath = downloadDir + "/" + fileName;
            try {
                if(packageName.startsWith("rycache_")){
                    Log.d(TAG, "find app cache,delete it...");
                    ExecuteCmdUtils.deletePkg(downloadPath);
                    continue;
                }
                mAppInfoQueue.put(new AppInfo(packageName, downloadPath));
                String msg = PushMsgUtils.createPushMsg(packageName, null, null,
                        AppState.APP_DOWNLOADED_AND_PARPARE_TO_INSTALL);
                mService.sendMsgToClient(msg);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }


    public void downloadAppLoop(){
        while(needRunning){
            MyLog.d("downloadAppLoop");
            try {
                Thread.sleep(5*1000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            MyLog.d("开始获取下载连接1: ");
            String url=getDwonURL();
//            String url="http://adinsights-new.oss-cn-huhehaote.aliyuncs.com/ad_union%2Fpackage%2Fpackage_79b00e464f57b8a3ea88926d1b3f9a91.apk?OSSAccessKeyId=LTAI4G7uVtsTvSYaa1ekxQoF&Expires=1656672566&Signature=%2FLw%2Bo1mTLTYDh%2FDFQaLuMIr8c8w%3D";

            MyLog.d("获取到的下载地址: "+url);
            setNetWorkCallback();

            String ts = String.valueOf(System.currentTimeMillis());
            String downloadPath = downloadDir + "/" + "rycache_" + ts + ".apk";
             String biaozhi= downloadApp(url, downloadPath);
//            String pkgName = downloadApp(downloadAppUrlStr, downloadPath);
            MyLog.d("下载获取的包名："+biaozhi+" 下载地址："+downloadPath);
            String pkgName =null;
            pkgName=getPackageName(downloadPath,pkgName);

//            MyLog.d("下载获取的包名->重新获取包名======== "+pkgName);
            if(pkgName == null) {
                ExecuteCmdUtils.deletePkg(downloadPath);
                MyLog.d("删除包信息..开始等待5分钟..");
                try {
                    sleep(1*60*1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                continue;
            }

            String newPath = downloadDir + "/" + pkgName + ".apk";
            renameFile(downloadPath, newPath);

            uploadDownLoadSuccessData(biaozhi);

            try {
                mAppInfoQueue.put(new AppInfo(pkgName, newPath));
                String msg = PushMsgUtils.createPushMsg(pkgName, null, null,
                        AppState.APP_DOWNLOADED_AND_PARPARE_TO_INSTALL);
                mService.sendMsgToClient(msg);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }



    public String getPackageName(String downloadPath,String pkgName){
        String result_pkg=null;
        for (int i = 0; i < 3; i++) {
            String code=installApp(downloadPath);
            MyLog.d("getPackageName-> "+code);
            if (code==null){
                return code;
            }else if (code.contains("INSTALL_FAILED_ALREADY_EXISTS")){
                int start=code.indexOf("re-install")+11;
                int end=code.indexOf("without first");
                result_pkg=code.substring(start,end).trim();
                MyLog.d("getPackageName-> 返回的 "+result_pkg);
                break;
            }
        }


//        ArrayList<String> after_name=getAppPackageName();
//
//        MyLog.d("getPackageName -> after_name "+after_name.size());
//        for (int i = 0; i < after_name.size(); i++) {
//            String item=after_name.get(i);
//            MyLog.d("getPackageName -> after_name "+item);
//            if (!before_name.contains(item)){
//                MyLog.d("获取到的APP 包名: "+item);
//                result_pkg=item;
//                break;
//            }
//        }



        return result_pkg;
    }

    public  String installApp(String downloadPath){
        String cmd = "pm install " + downloadPath;
        ArrayList<String>result=Tool.rootCommand(cmd);
        if (result==null)return null;
        String type=result.get(0);
        if (type.equals("success")){
            MyLog.d("installApp->安装APP： " + downloadPath+" -> 成功");
            return "success:";
        }
        String errorMsg=result.get(1);
        if (errorMsg.contains("INSTALL_FAILED_ALREADY_EXISTS")){
            return errorMsg;
        }else{
            MyLog.d("installApp->安装APP： " + downloadPath+" -> 失败 : "+errorMsg);
            return null;
        }
    }

    public void deleApp(){

        ArrayList<String> result=getAppPackageName();

        for (int i = 0; i < result.size(); i++) {
            String pkgName= result.get(i);
            ExecuteCmdUtils.finishApp(pkgName);
            MyLog.d("deleApp-> "+pkgName+"  result: "+uninstallApp(pkgName));
            ;
        }

    }

    public  boolean uninstallApp(String packageName){
        String cmd = "pm uninstall " + packageName;
        ArrayList<String>result=Tool.rootCommand(cmd);
        if (result==null)return false;
        String type=result.get(0);
        MyLog.d("uninstallapp->卸载APP："+type);
        if (type.equals("success")){
            MyLog.d("uninstallapp->卸载APP： " + packageName+" -> 成功");
            return true;
        }
        MyLog.d("uninstallapp->卸载APP： " + packageName+" -> 失败");
        return result!=null;
    }

    public ArrayList<String> getAppPackageName(){
        ArrayList<String> result=new ArrayList<>();

        ArrayList<String> arrayList= Tool.rootCommand("ls /data/app -l");
        for (int i = 2; i < arrayList.size(); i++) {
            String item=arrayList.get(i);
            try {
//                    d("getPackageName-> 获取的包名1："+item);
                String[]strings=item.split(" ");
                String str=strings[7];
//                    d("getPackageName-> 获取的包名1："+str);
                str=str.split("-")[0];
//                    d("getPackageName-> 获取的包名2："+str);
                item=str;
                if ((!item.contains("com.google"))
                        &&(!item.contains("com.topjohnwu.magisk"))
                        &&(!item.contains("com.fear1ess"))
                        &&(!item.contains("com.magic"))  //
                        &&(!item.contains("org.meowcat.edxposed.manager"))
                        &&(!item.contains("bin.mt.plus"))
//                        &&(!item.contains("org.meowcat.edxposed.manager"))
                ){
                    result.add(str.trim());
                    MyLog.d("getPackageName-> 获取的包名1："+item);
                }
            }catch (Exception e){
                MyLog.d(e.toString());
                item="error";
            };

        }
        if (result.size()>2){
            result.remove(0);
            result.remove(1);
        }

        return result;
    }



    public void uploadDownLoadSuccessData(String pkgName) {
        Log.d(TAG, "start upload download success data...");
        ExecutorService es = Executors.newSingleThreadExecutor();
        JSONObject jo = new JSONObject();
        try {
            jo.put("app_id", pkgName);
            jo.put("download_success", 1);
            MyLog.d("uploadDownLoadSuccessData-> "+jo.toString());
        } catch (JSONException e) {
            e.printStackTrace();
        }
        es.execute(new UploadAdsDataProceduce(jo.toString()));
        es.shutdown();
    }

    public void setNetWorkCallback() {
        NetWorkUtils.setNetWorkCallback(new NetWorkUtils.NetWorkCallback() {
            @Override
            public void onDownloadPkgNameGetSuccess(String name) {
                String msg = PushMsgUtils.createPushMsg(name, null, null, 0,
                        AppState.APP_DOWNLOADING);
                mService.sendMsgToClient(msg);
            }

            @Override
            public void onDownloadPkgNameGetfailed() {
            }

            @Override
            public void onDownloadBytesUpdate(String name, int bytesDownloaded) {
                String msg = PushMsgUtils.createPushMsg(name, null, null, bytesDownloaded,
                        AppState.APP_DOWNLOADING);
                mService.sendMsgToClient(msg);
            }
        });
    }

    @Override
    public void run() {

        //handle local app
        handleLocalApp();

        //download app loop...
        downloadAppLoop();
    }
}
